import { autocompletion as H, completionKeymap as j, closeBrackets as B, closeBracketsKeymap as I } from "@codemirror/autocomplete";
import { indentWithTab as O, insertNewline as K } from "@codemirror/commands";
import { css as L } from "@codemirror/lang-css";
import { html as R } from "@codemirror/lang-html";
import { json as V } from "@codemirror/lang-json";
import { xml as A } from "@codemirror/lang-xml";
import { yaml as z } from "@codemirror/lang-yaml";
import { syntaxHighlighting as J, defaultHighlightStyle as P, indentOnInput as U, bracketMatching as v } from "@codemirror/language";
import { linter as W } from "@codemirror/lint";
import { StateEffect as q } from "@codemirror/state";
import { EditorView as h, highlightSpecialChars as D, keymap as u, placeholder as G, lineNumbers as Q } from "@codemirror/view";
import { ref as X, watch as m, onBeforeUnmount as Y, toValue as t, computed as Z } from "vue";
import { customTheme as _ } from "../themes/index.js";
import { variables as $ } from "./variables.js";
const d = (e) => "provider" in e && !!t(e.provider), F = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, me = (e) => {
  const r = X(null);
  m(
    e.codeMirrorRef,
    () => {
      var o;
      (o = r.value) == null || o.destroy(), l();
    },
    { immediate: !0 }
  ), Y(() => {
    var o;
    return (o = r.value) == null ? void 0 : o.destroy();
  });
  function l() {
    if (e.codeMirrorRef.value) {
      const o = d(e) ? t(e.provider) : null, a = x({
        ...s.value,
        provider: o
      });
      r.value = new h({
        parent: e.codeMirrorRef.value,
        extensions: a
      }), d(e) || n(t(e.content));
    }
  }
  const s = Z(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    disableTabIndent: t(e.disableTabIndent),
    language: t(e.language),
    classes: t(e.classes),
    readOnly: t(e.readOnly),
    lineNumbers: t(e.lineNumbers),
    withVariables: t(e.withVariables),
    disableEnter: t(e.disableEnter),
    disableCloseBrackets: t(e.disableCloseBrackets),
    withoutTheme: t(e.withoutTheme),
    lint: t(e.lint),
    additionalExtensions: t(e.extensions),
    placeholder: t(e.placeholder)
  }));
  m(
    () => d(e) ? t(e.provider) : null,
    () => {
      var o;
      d(e) && ((o = r.value) == null || o.destroy(), l());
    }
  ), m(
    s,
    () => {
      if (r.value) {
        const o = d(e) ? t(e.provider) : null, a = x({
          ...s.value,
          provider: o
        });
        r.value.dispatch({
          effects: q.reconfigure.of(a)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const n = (o = "") => {
    r.value && r.value.state.doc.toString() !== o && r.value.dispatch({
      changes: {
        from: 0,
        to: r.value.state.doc.length,
        insert: o
      },
      selection: {
        anchor: Math.min(
          r.value.state.selection.main.anchor,
          o.length
        )
      }
    });
  };
  return m(
    () => t(e.content),
    () => {
      d(e) || n(t(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: n,
    /** Codemirror instance */
    codeMirror: r
  };
}, y = {
  html: R,
  json: V,
  yaml: z,
  css: L,
  xml: A
};
function x({
  onChange: e,
  onBlur: r,
  onFocus: l,
  provider: s,
  language: n,
  classes: o = [],
  readOnly: a = !1,
  lineNumbers: E = !1,
  withVariables: k = !1,
  disableEnter: C = !1,
  disableCloseBrackets: M = !1,
  disableTabIndent: S = !1,
  withoutTheme: T = !1,
  lint: N = !1,
  additionalExtensions: w = [],
  placeholder: g
}) {
  const i = [
    D(),
    J(P, { fallback: !0 }),
    h.theme({
      ".cm-line": {
        lineHeight: "20px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      }
    }),
    // Listen to updates
    h.updateListener.of((f) => {
      f.docChanged && (e == null || e(f.state.doc.toString()));
    }),
    h.domEventHandlers({
      blur: (f, c) => {
        r == null || r(c.state.doc.toString());
      },
      focus: (f, c) => {
        l == null || l(c.state.doc.toString());
      }
    }),
    // Add Classes
    h.editorAttributes.of({ class: o.join(" ") }),
    ...w
  ];
  if (s && i.push(s), T || i.push(_), a ? i.push(h.editable.of(!1)) : (i.push(
    U(),
    v(),
    H(),
    u.of([...j, F]),
    v()
  ), M || i.push(B(), u.of([...I])), S ? i.push(
    u.of([
      {
        key: "Tab",
        run: () => !1,
        // Prevent default Tab behavior
        shift: () => !1
        // Prevent default Shift+Tab behavior
      }
    ])
  ) : i.push(u.of([O]))), g && i.push(G(g)), n && y[n] && i.push(y[n]()), N && n === "json") {
    const f = W((c) => {
      const p = [];
      try {
        JSON.parse(c.state.doc.toString());
      } catch (b) {
        b instanceof Error && p.push({
          from: 0,
          to: c.state.doc.length,
          severity: "error",
          message: b.message
        });
      }
      return p;
    });
    i.push(f);
  }
  return E && i.push(Q()), k && i.push($()), C ? i.push(
    u.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ) : i.push(
    u.of([
      {
        key: "Enter",
        run: K
      }
    ])
  ), i;
}
export {
  me as useCodeMirror
};
